/*
 There are five houses.

  1. The Englishman lives in the red house.
  2. The Spaniard owns the dog.
  3. Coffee is drunk in the green house.
  4. The Ukrainian drinks tea.
  5. The green house is immediately to the right of the ivory house.
  6. The Old Gold smoker owns snails.
  7. Kools are smoked in the yellow house.
  8. Milk is drunk in the middle house.
  9. The Norwegian lives in the first house.
 10. The man who smokes Chesterfields lives in the house next to
     the man with the fox.
 11. Kools are smoked in a house next to the house where the horse is kept.
 12. The Lucky Strike smoker drinks orange juice.
 13. The Japanese smokes Parliaments.
 14. The Norwegian lives next to the blue house.

 Now, who drinks water? Who owns the zebra?

 In the interest of clarity, it must be added that each of the five
 houses is painted a different color, and their inhabitants are of
 different national extractions, own different pets, drink different
 beverages and smoke different brands of American cigarets [sic]. In
 statement 6, right refers to the reader's right.
*/

/* house(Nationality, Color, Animal, Drink, Smoke) */

zebra(Houses) :-
    Houses = [house(norwegian, _, _, _, _),
	      house(_, blue, _, _, _),
              house(_, _, _, milk, _), _, _],
    member(house(englishman, red, _, _, _), Houses),
    member(house(spaniard, _, dog, _, _), Houses),
    member(house(_, green, _, coffee, _), Houses),
    member(house(ukranian, _, _, tea, _), Houses),
    right_of(house(_, ivory, _, _, _), house(_, green, _, _, _), Houses),
    member(house(_, _, snails, _, old_gold), Houses),
    member(house(_, yellow, _, _, kools), Houses),
    next_to(house(_, _, _, _, chesterfields), house(_, _, fox, _, _), Houses),
    next_to(house(_, _, _, _, kools), house(_, _, horse, _, _), Houses),
    member(house(_, _, _, orange_juice, lucky_strike), Houses),
    member(house(japanese, _, _, _, parliaments), Houses).

right_of(X, Y, [X, Y|_]).
right_of(X, Y, [_, X, Y|_]).
right_of(X, Y, [_, _, X, Y|_]).
right_of(X, Y, [_, _, _, X, Y]).

next_to(X, Y, Houses) :- right_of(X, Y, Houses).
next_to(X, Y, Houses) :- right_of(Y, X, Houses).
